


\newcommand{\legenda}{\begin{center}Legenda: ``A'': Automatic, ``S'': Semi-Automatic.``M'': Manual,  "-" : No License applied\end{center}} 
\newcommand{\header}{
	\textbf{Tool Name} & \textbf{Covered Attacks/Vuln \cite{helsinki_owasp}\cite{best_current_practice}}&\textbf{A/S/M}& \textbf{Availability} & \textbf{Licence}& \textbf{MIG} & \textbf{Language} & \textbf{Platform}}

%%%%%%%%%%%%%%%BEGIN TABLE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{table}[h!b]
        \fontsize{8}{10}\selectfont 
	\centering
	\renewcommand{\arraystretch}{1.2}\resizebox{\textwidth}{!}{
	\begin{tabular}{@{}p{4cm}lcccccc@{}} 
		\toprule
		% compliance, active/passive, 
		\header
		\\
		\midrule
		%%%%%%%%%%%%%%%%General%%%%%%%%%%%%%%%%%%%%%%%%
		\multicolumn{6}{l}{\textbf{Target: Any}}\\
		\midrule
		
		
		&&&&&\\
		
		oauth2-redirector\cite{oauth2-redirector} & CSRF(state parameter) & S\tablefootnote{Login and authorization required} & Yes & MIT & & Ruby & Web \\
		
		&&&&&\\
		
		oauth2-client-tester\cite{oauth2clienttester} & Checks for correct 3-way handshake & A & Yes & -  & & Ruby & Web\\
		
		&&&&&\\
		
		\bottomrule

%		%%%%%%%%%%%%%%%%IdP%%%%%%%%%%%%%%%%%%%%%%%%
        \multicolumn{6}{l}{\textbf{Target: IdP Role}}\\

 
		\midrule
		
		&&&&&\\
		
		\multirow{2}{*}{MoSSOT\cite{shi2019mossot}}& Credential disclosure & \multirow{2}{*}{A} & \multirow{2}{*}{Yes} & \multirow{2}{*}{Apache2} & &\multirow{2}{*}{Python}&\multirow{2}{*}{Mobile}\\
		&Previously unknown vuln. IdP&&&&&\\
		
			
		&&&&&&&\\
		
		LinkedIn Oauth Tester\cite{linkedin} & Checks for correct token creation on Linkedin & A  & Yes  & -  & &Ruby & Web \\
		
		&&&&&\\
		\bottomrule 	
	\end{tabular}}

\caption{Collection of Tools.}\label{table:tools1} 
\legenda
\end{table}
%%%%%%%%%%%%%%%END  TABLE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newpage

\begin{table}[h!b]
	\fontsize{8}{10}\selectfont 
	\centering
	\renewcommand{\arraystretch}{1.2}\resizebox{\textwidth}{!}{
	\begin{tabular}{@{}p{4cm}lcccccc@{}} 
		\toprule
		% compliance, active/passive, 
		\header
		\\
		\midrule
		%%%%%%%%%%%%%%%%General%%%%%%%%%%%%%%%%%%%%%%%%
		
		
		\multicolumn{6}{l}{\textbf{Target: Client Role}}\\
		\midrule
		
		&&&&&\\
		\multirow{4}{*}{MoSSOT\cite{shi2019mossot}}& Profile Vulnerability & \multirow{4}{*}{A} & \multirow{4}{*}{Yes} & \multirow{4}{*}{Apache2} & & \multirow{4}{*}{Python}& \multirow{4}{*}{Mobile}\\
		&App secret disclosure & & & &\\
		&Access Token Replacement & & & &\\
		&Augmented Access Token Replacement&&&&\\
		
		&&&&&\\
		\multirow{3}{*}{OAuth - Vuln. scanner\cite{oauthvulnscanner}}& Too big token lifetime & \multirow{3}{*}{S\tablefootnote{Authorization required}} & \multirow{3}{*}{Yes} & \multirow{3}{*}{-} & &\multirow{3}{*}{Python} & \multirow{3}{*}{Web} \\	
		&Token transmitted using TLS & & & & &&\\	
		&Weak JWT sign method & & & & &&\\
		
		&&&&&\\
		
		\multirow{5}{*}{AuthScan\cite{bai2013authscan}}& Replay attack in BrowserId & \multirow{5}{*}{A}  & \multirow{5}{*}{No} & \multirow{5}{*}{-} & & \multirow{5}{*}{?} &\multirow{5}{*}{Web} \\
		&CSRF attack in BrowserID&&&&&&\\&Secret Token Leak in Facebook Connect&&&&&&\\&Non-secret Token in Using Windows Live ID&&&&&&\\&Guessable Token in Standalone Sites&&&&&&\\
		
		&&&&&\\
		
		\multirow{4}{*}{Overscan\cite{siriporn2019overscan}} & X-CSRF Token attack & \multirow{4}{*}{A} & \multirow{4}{*}{Yes} & \multirow{4}{*}{-} & &\multirow{4}{*}{Java} &\multirow{4}{*}{Web} \\ & CSRF & & & & \\ & Auth. Code phishing & & & & \\ & Clickjacking & & & & \\
		
		&&&&&\\
		
		AuthScope\cite{zuo2017authscope} & Sensitive and secret data leakage & A & No & - & &? & Mobile\\
		
		&&&&&\\
		
		\multirow{5}{*}{OAuthGuard\cite{oauthguard}} & Unsafe Token Transfer& \multirow{5}{*}{A} & \multirow{5}{*}{Yes} & \multirow{5}{*}{GNU/GPL3}& &\multirow{5}{*}{JavaScript}&\multirow{5}{*}{Web}\\
		&CSRF & & & & \\
		& Impersonation& & & & \\
		& Privacy Leaks& & & & \\
		& OAuth flow misuse& & & & \\
		
		&&&&&\\
		
		\multirow{6}{*}{PrOfESSOS\cite{professos}}& Issuer confusion & \multirow{6}{*}{A} & \multirow{6}{*}{Yes} & \multirow{6}{*}{Apache2} & &\multirow{6}{*}{Java}&\multirow{6}{*}{Web}\\
		& ID spoofing & & & & \\
		& Reply Attacks & & & & \\
		& Signiture Bypass & & & & \\
		& IdP Confusion & & & & \\
		& Malicious Endpoint & & & & \\
		
		&&&&&\\
		
		\multirow{3}{*}{WPSE\cite{wpse}} &Mix-IdP&\multirow{3}{*}{A}&\multirow{3}{*}{Yes}&\multirow{3}{*}{-} && \multirow{3}{*}{JavaScript}&\multirow{3}{*}{Web}\\
		&CSRF&&&&\\
		&Privacy Leaks&&&&\\
		
		&&&&&\\
		
		\multirow{5}{*}{SSOScan\cite{ssoscan}} &Access Token misuse & \multirow{5}{*}{A} & \multirow{5}{*}{Yes} & \multirow{5}{*}{-}&&\multirow{5}{*}{JavaScript}&\multirow{5}{*}{Web}\\
		& Signed request misuse & & & & \\
		& Credential leakage via Referrer& & & & \\
		& Secret Leakage& & & & \\
		& Credential Leakage via page content& & & & \\
		
		&&&&&\\
		
		\bottomrule
		%		%%%%%%%%%%%%%%%%IdP%%%%%%%%%%%%%%%%%%%%%%%%
		
	\end{tabular}}
\caption{Collection of Tools.}\label{table:tools2}
	\legenda
\end{table}

